Index: src/tesselation.cpp
===================================================================
--- src/tesselation.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/tesselation.cpp	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
@@ -2982,5 +3134,5 @@
 
   if (Point == NULL) {
-    Log() << Verbose(1) << "ERROR: Point given is NULL." << endl;
+    eLog() << Verbose(1) << "Point given is NULL." << endl;
   } else {
     // go through its lines and insert all triangles
@@ -3014,5 +3166,5 @@
 
   if (point == NULL) {
-    Log() << Verbose(1) << "ERROR: Cannot remove the point " << point << ", it's NULL!" << endl;
+    eLog() << Verbose(1) << "Cannot remove the point " << point << ", it's NULL!" << endl;
     return 0.;
   } else
@@ -3024,5 +3176,5 @@
   // get list of connected points
   if (point->lines.empty()) {
-    Log() << Verbose(1) << "ERROR: Cannot remove the point " << *point << ", it's connected to no lines!" << endl;
+    eLog() << Verbose(1) << "Cannot remove the point " << *point << ", it's connected to no lines!" << endl;
     return 0.;
   }
@@ -3124,5 +3276,5 @@
         triangle = GetPresentTriangle(TriangleCandidates);
         if (triangle != NULL) {
-          Log() << Verbose(1) << "WARNING: New triangle already present, skipping!" << endl;
+          eLog() << Verbose(2) << "New triangle already present, skipping!" << endl;
           StartNode++;
           MiddleNode++;
@@ -3433,4 +3585,6 @@
   }
   delete(DegeneratedTriangles);
+  if (count > 0)
+    LastTriangle = NULL;
 
   Log() << Verbose(1) << "RemoveDegeneratedTriangles() removed " << count << " triangles:" << endl;
@@ -3462,5 +3616,5 @@
     NearestBoundaryPoint = PointRunner->second;
   } else {
-    Log() << Verbose(1) << "ERROR: I cannot find the boundary point." << endl;
+    eLog() << Verbose(1) << "I cannot find the boundary point." << endl;
     return;
   }
Index: src/tesselation.hpp
===================================================================
--- src/tesselation.hpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/tesselation.hpp	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
@@ -170,4 +170,5 @@
   virtual ~PointCloud();
 
+  virtual const char * const GetName() const { return "unknown"; };
   virtual Vector *GetCenter() const { return NULL; };
   virtual TesselPoint *GetPoint() const { return NULL; };
@@ -177,6 +178,6 @@
   virtual void GoToFirst() const {};
   virtual void GoToLast() const {};
-  virtual bool IsEmpty() const { return false; };
-  virtual bool IsEnd() const { return false; };
+  virtual bool IsEmpty() const { return true; };
+  virtual bool IsEnd() const { return true; };
 };
 
@@ -205,4 +206,5 @@
 
     void AddTesselationPoint(TesselPoint* Candidate, const int n);
+    void SetTesselationPoint(TesselPoint* Candidate, const int n) const;
     void AddTesselationLine(class BoundaryPointSet *a, class BoundaryPointSet *b, const int n);
     void AlwaysAddTesselationTriangleLine(class BoundaryPointSet *a, class BoundaryPointSet *b, const int n);
@@ -217,7 +219,7 @@
     void FindStartingTriangle(const double RADIUS, const LinkedCell *LC);
     void FindSecondPointForTesselation(class TesselPoint* a, Vector Oben, class TesselPoint*& OptCandidate, double Storage[3], double RADIUS, const LinkedCell *LC);
-    void FindThirdPointForTesselation(Vector NormalVector, Vector SearchDirection, Vector OldSphereCenter, class BoundaryLineSet *BaseLine, class TesselPoint *ThirdNode, CandidateList* &candidates, double *ShortestAngle, const double RADIUS, const LinkedCell *LC);
+    void FindThirdPointForTesselation(Vector &NormalVector, Vector &SearchDirection, Vector &OldSphereCenter, class BoundaryLineSet *BaseLine, const class TesselPoint * const ThirdNode, CandidateList* &candidates, double *ShortestAngle, const double RADIUS, const LinkedCell *LC) const;
     bool FindNextSuitableTriangle(BoundaryLineSet &Line, BoundaryTriangleSet &T, const double& RADIUS, const LinkedCell *LC);
-    int CheckPresenceOfTriangle(class TesselPoint *Candidates[3]);
+    int CheckPresenceOfTriangle(class TesselPoint *Candidates[3]) const;
     class BoundaryTriangleSet * GetPresentTriangle(TesselPoint *Candidates[3]);
 
@@ -281,7 +283,9 @@
 
   private:
-    class BoundaryPointSet *TPS[3]; //this is a Storage for pointers to triangle points, this and BPS[2] needed due to AddLine restrictions
+    mutable class BoundaryPointSet *TPS[3]; //this is a Storage for pointers to triangle points, this and BPS[2] needed due to AddLine restrictions
 
     mutable PointMap::const_iterator InternalPointer;
+
+    bool HasOtherBaselineBetterCandidate(const BoundaryLineSet * const BaseRay, const TesselPoint * const OptCandidate, double ShortestAngle, double RADIUS, const LinkedCell * const LC) const;
 };
 
Index: src/tesselationhelpers.cpp
===================================================================
--- src/tesselationhelpers.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/tesselationhelpers.cpp	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
@@ -77,5 +77,5 @@
 
   if (fabs(m11) < MYEPSILON)
-    eLog() << Verbose(0) << "ERROR: three points are colinear." << endl;
+    eLog() << Verbose(1) << "three points are colinear." << endl;
 
   center->x[0] =  0.5 * m12/ m11;
@@ -84,5 +84,5 @@
 
   if (fabs(a.Distance(center) - RADIUS) > MYEPSILON)
-    eLog() << Verbose(0) << "ERROR: The given center is further way by " << fabs(a.Distance(center) - RADIUS) << " from a than RADIUS." << endl;
+    eLog() << Verbose(1) << "The given center is further way by " << fabs(a.Distance(center) - RADIUS) << " from a than RADIUS." << endl;
 
   gsl_matrix_free(A);
@@ -187,6 +187,7 @@
   gamma = M_PI - SideA.Angle(&SideB);
   //Log() << Verbose(3) << "INFO: alpha = " << alpha/M_PI*180. << ", beta = " << beta/M_PI*180. << ", gamma = " << gamma/M_PI*180. << "." << endl;
-  if (fabs(M_PI - alpha - beta - gamma) > HULLEPSILON)
-    eLog() << Verbose(0) << "GetCenterofCircumcircle: Sum of angles " << (alpha+beta+gamma)/M_PI*180. << " > 180 degrees by " << fabs(M_PI - alpha - beta - gamma)/M_PI*180. << "!" << endl;
+  if (fabs(M_PI - alpha - beta - gamma) > HULLEPSILON) {
+    eLog() << Verbose(1) << "GetCenterofCircumcircle: Sum of angles " << (alpha+beta+gamma)/M_PI*180. << " > 180 degrees by " << fabs(M_PI - alpha - beta - gamma)/M_PI*180. << "!" << endl;
+  }
 
   Center->Zero();
@@ -224,5 +225,5 @@
   // test whether new center is on the parameter circle's plane
   if (fabs(helper.ScalarProduct(&CirclePlaneNormal)) > HULLEPSILON) {
-    eLog() << Verbose(0) << "ERROR: Something's very wrong here: NewSphereCenter is not on the band's plane as desired by " <<fabs(helper.ScalarProduct(&CirclePlaneNormal))  << "!" << endl;
+    eLog() << Verbose(1) << "Something's very wrong here: NewSphereCenter is not on the band's plane as desired by " <<fabs(helper.ScalarProduct(&CirclePlaneNormal))  << "!" << endl;
     helper.ProjectOntoPlane(&CirclePlaneNormal);
   }
@@ -230,5 +231,5 @@
   // test whether the new center vector has length of CircleRadius
   if (fabs(radius - CircleRadius) > HULLEPSILON)
-    eLog() << Verbose(1) << "ERROR: The projected center of the new sphere has radius " << radius << " instead of " << CircleRadius << "." << endl;
+    eLog() << Verbose(1) << "The projected center of the new sphere has radius " << radius << " instead of " << CircleRadius << "." << endl;
   alpha = helper.Angle(&OldSphereCenter);
   // make the angle unique by checking the halfplanes/search direction
@@ -461,5 +462,8 @@
   for (int i=0;i<3;i++)
     for (int j=i+1; j<3; j++) {
-      if (nodes[i]->lines.find(nodes[j]->node->nr) != nodes[i]->lines.end()) {  // there already is a line
+      if (nodes[i] == NULL) {
+        Log() << Verbose(1) << "Node nr. " << i << " is not yet present." << endl;
+        result = true;
+      } else if (nodes[i]->lines.find(nodes[j]->node->nr) != nodes[i]->lines.end()) {  // there already is a line
         LineMap::const_iterator FindLine;
         pair<LineMap::const_iterator,LineMap::const_iterator> FindPair;
@@ -491,5 +495,5 @@
   Vector BaseLineVector, OrthogonalVector, helper;
   if (candidate1->BaseLine != candidate2->BaseLine) {  // sanity check
-    Log() << Verbose(0) << "ERROR: sortCandidates was called for two different baselines: " << candidate1->BaseLine << " and " << candidate2->BaseLine << "." << endl;
+    eLog() << Verbose(1) << "sortCandidates was called for two different baselines: " << candidate1->BaseLine << " and " << candidate2->BaseLine << "." << endl;
     //return false;
     exit(1);
@@ -574,5 +578,5 @@
           }
         } else {
-          eLog() << Verbose(0) << "ERROR: The current cell " << LC->n[0] << "," << LC->n[1] << ","
+          eLog() << Verbose(1) << "The current cell " << LC->n[0] << "," << LC->n[1] << ","
             << LC->n[2] << " is invalid!" << endl;
         }
@@ -630,5 +634,5 @@
           }
         } else {
-          eLog() << Verbose(0) << "ERROR: The current cell " << LC->n[0] << "," << LC->n[1] << ","
+          eLog() << Verbose(1) << "The current cell " << LC->n[0] << "," << LC->n[1] << ","
             << LC->n[2] << " is invalid!" << endl;
         }
@@ -738,5 +742,5 @@
     }
   } else {
-    eLog() << Verbose(0) << "ERROR: Given vrmlfile is " << vrmlfile << "." << endl;
+    eLog() << Verbose(1) << "Given vrmlfile is " << vrmlfile << "." << endl;
   }
   delete(center);
@@ -752,18 +756,21 @@
 {
   Vector helper;
-  // include the current position of the virtual sphere in the temporary raster3d file
-  Vector *center = cloud->GetCenter();
-  // make the circumsphere's center absolute again
-  helper.CopyVector(Tess->LastTriangle->endpoints[0]->node->node);
-  helper.AddVector(Tess->LastTriangle->endpoints[1]->node->node);
-  helper.AddVector(Tess->LastTriangle->endpoints[2]->node->node);
-  helper.Scale(1./3.);
-  helper.SubtractVector(center);
-  // and add to file plus translucency object
-  *rasterfile << "# current virtual sphere\n";
-  *rasterfile << "8\n  25.0    0.6     -1.0 -1.0 -1.0     0.2        0 0 0 0\n";
-  *rasterfile << "2\n  " << helper.x[0] << " " << helper.x[1] << " " << helper.x[2] << "\t" << 5. << "\t1 0 0\n";
-  *rasterfile << "9\n  terminating special property\n";
-  delete(center);
+
+  if (Tess->LastTriangle != NULL) {
+    // include the current position of the virtual sphere in the temporary raster3d file
+    Vector *center = cloud->GetCenter();
+    // make the circumsphere's center absolute again
+    helper.CopyVector(Tess->LastTriangle->endpoints[0]->node->node);
+    helper.AddVector(Tess->LastTriangle->endpoints[1]->node->node);
+    helper.AddVector(Tess->LastTriangle->endpoints[2]->node->node);
+    helper.Scale(1./3.);
+    helper.SubtractVector(center);
+    // and add to file plus translucency object
+    *rasterfile << "# current virtual sphere\n";
+    *rasterfile << "8\n  25.0    0.6     -1.0 -1.0 -1.0     0.2        0 0 0 0\n";
+    *rasterfile << "2\n  " << helper.x[0] << " " << helper.x[1] << " " << helper.x[2] << "\t" << 5. << "\t1 0 0\n";
+    *rasterfile << "9\n  terminating special property\n";
+    delete(center);
+  }
 };
 
@@ -808,5 +815,5 @@
     *rasterfile << "9\n#  terminating special property\n";
   } else {
-    eLog() << Verbose(0) << "ERROR: Given rasterfile is " << rasterfile << "." << endl;
+    eLog() << Verbose(1) << "Given rasterfile is " << rasterfile << "." << endl;
   }
   IncludeSphereinRaster3D(rasterfile, Tess, cloud);
@@ -825,7 +832,12 @@
     *tecplot << "TITLE = \"3D CONVEX SHELL\"" << endl;
     *tecplot << "VARIABLES = \"X\" \"Y\" \"Z\" \"U\"" << endl;
-    *tecplot << "ZONE T=\"" << N << "-";
-    for (int i=0;i<3;i++)
-      *tecplot << (i==0 ? "" : "_") << TesselStruct->LastTriangle->endpoints[i]->node->Name;
+    *tecplot << "ZONE T=\"";
+    if (N < 0) {
+      *tecplot << cloud->GetName();
+    } else {
+      *tecplot << N << "-";
+      for (int i=0;i<3;i++)
+        *tecplot << (i==0 ? "" : "_") << TesselStruct->LastTriangle->endpoints[i]->node->Name;
+    }
     *tecplot << "\", N=" << TesselStruct->PointsOnBoundary.size() << ", E=" << TesselStruct->TrianglesOnBoundary.size() << ", DATAPACKING=POINT, ZONETYPE=FETRIANGLE" << endl;
     int i=0;
Index: src/vector.cpp
===================================================================
--- src/vector.cpp	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ src/vector.cpp	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
@@ -229,5 +229,5 @@
   factor = Direction.ScalarProduct(PlaneNormal);
   if (factor < MYEPSILON) { // Uniqueness: line parallel to plane?
-    Log() << Verbose(2) << "WARNING: Line is parallel to plane, no intersection." << endl;
+    eLog() << Verbose(2) << "Line is parallel to plane, no intersection." << endl;
     return false;
   }
@@ -253,5 +253,5 @@
     return true;
   } else {
-    Log() << Verbose(2) << "WARNING: Intersection point " << *this << " is not on plane." << endl;
+    eLog() << Verbose(2) << "Intersection point " << *this << " is not on plane." << endl;
     return false;
   }
@@ -747,5 +747,5 @@
       x[i] = C.x[i];
   } else {
-    eLog() << Verbose(0) << "ERROR: inverse of matrix does not exists: det A = " << detA << "." << endl;
+    eLog() << Verbose(1) << "inverse of matrix does not exists: det A = " << detA << "." << endl;
   }
 };
@@ -799,5 +799,5 @@
   x2.SubtractVector(y2);
   if ((fabs(x1.Norm()) < MYEPSILON) || (fabs(x2.Norm()) < MYEPSILON) || (fabs(x1.Angle(&x2)) < MYEPSILON)) {
-    Log() << Verbose(4) << "WARNING: Given vectors are linear dependent." << endl;
+    eLog() << Verbose(2) << "Given vectors are linear dependent." << endl;
     return false;
   }
@@ -833,5 +833,5 @@
   Zero();
   if ((fabs(x1.Norm()) < MYEPSILON) || (fabs(x2.Norm()) < MYEPSILON) || (fabs(x1.Angle(&x2)) < MYEPSILON)) {
-    Log() << Verbose(4) << "WARNING: Given vectors are linear dependent." << endl;
+    eLog() << Verbose(2) << "Given vectors are linear dependent." << endl;
     return false;
   }
Index: tests/Tesselations/Makefile.am
===================================================================
--- tests/Tesselations/Makefile.am	(revision 3a0b3890298aafb5853dc67311a7ba037e2e94b4)
+++ tests/Tesselations/Makefile.am	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
@@ -2,4 +2,5 @@
 1_2-dimethylbenzene.test \
 2-methylcyclohexanone.test \
+benzene.test \
 cholesterol.test \
 cluster.test \
Index: tests/Tesselations/benzene.test
===================================================================
--- tests/Tesselations/benzene.test	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
+++ tests/Tesselations/benzene.test	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
@@ -0,0 +1,8 @@
+#! /bin/sh
+
+# Test a simple simulation: 
+
+. ./defs || exit 1
+set -e
+
+Tesselation_run 0 4.
Index: tests/Tesselations/benzene/benzene.xyz
===================================================================
--- tests/Tesselations/benzene/benzene.xyz	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
+++ tests/Tesselations/benzene/benzene.xyz	(revision ebbd3d3e47035ead60a750b80c7f05742071fd11)
@@ -0,0 +1,14 @@
+12
+Benzene molecule
+H   -1.6271    0.0000   -0.0007
+C   -0.5471    0.0001   -0.0015
+C    0.1541    1.2073    0.0011
+C    0.1544   -1.2075    0.0010
+C    1.5338    1.2000    0.0007
+C    1.5336   -1.2001    0.0007
+C    2.2223    0.0002   -0.0021
+H   -0.3822    2.1448    0.0029
+H   -0.3819   -2.1449    0.0036
+H    2.0775    2.1332    0.0024
+H    2.0774   -2.1333    0.0026
+H    3.3023    0.0002   -0.0027
